; *** Banshee HD loader
; *** Written by Jean-Franois Fabre in september 2000
;
; A good OSEmu example, with patching done inside

HISCORE_LEN = $F0

	include  "syslibs.i"
	include  "jst.i"

	HD_PARAMS   "",0,0

loader:
	move.l	#$80000,D0
	JSRABS	AllocExtMem

	Mac_printf  "Banshee HD Loader v1.2"
	Mac_printf  "Coded by Jean-Franois Fabre  2000/2001"

	JSRGEN	CheckAGA
	tst.l	D0
	bne	AgaErr

	TESTFILE	introname
	beq.b	.intro
	RELOC_STL	nointro
.intro
	TESTFILE	progname
	bne.b	FileErr

	JSRABS	UseHarryOSEmu

	; loads hi-score file if found
	; Warning: must do this after UseHarryOSEmu is loaded
	; because using OSEmu involves that SAVEDIR and LOADDIR
	; are changed if not set or only set by env. variable

	bsr	LoadScore

	JSRABS	LoadFiles

	moveq.l	#0,D0
	move.l	#CACRF_CopyBack,D1
	JSRABS	Degrade

	GO_SUPERVISOR
	SAVE_OSDATA	$200000

	move	#0,SR

	bsr	InstallBoot

	; **** boot stuff and patch

	JSRGEN	FlushCachesHard

	jsr	(A2)

	; copy hiscore area to buffer for later use

	move.l	hiscore_address(pc),A0
	cmp.l	#0,A0
	beq.b	.skipcopy
	lea	ScoreBuffer(pc),A1
	move.l	#HISCORE_LEN,D0
	JSRGEN	CopyMem
.skipcopy:

	JSRGEN	InGameExit
.loop
	bra.b	.loop

SaveScore:
	lea	ScoreBuffer(pc),A1
	cmp.l	#'SHIT',(A1)
	beq.b	.skip
	tst.l	(A1)
	beq.b	.skip
	
	lea	ScoreName(pc),A0
	moveq.l	#0,D0
	move.l	#HISCORE_LEN,D1
	JSRGEN	WriteUserFileHD
	tst.l	D0
	beq.b	.skip
	Mac_printf	"** Hi-score file could not be saved"
	Mac_printf	"   Press RETURN"
	JSRABS	WaitReturn
.skip
	rts

LoadScore:
	lea	ScoreBuffer(pc),A1
	lea	ScoreName(pc),A0
	moveq.l	#0,D0
	moveq.l	#-1,D1
	JSRGEN	ReadUserFileHD
	tst.l	D0
	beq.b	.skip
	Mac_printf	"** Hi-score file not found"
.skip
	rts

InstallBoot:
	RELOC_TSTL	nointro
	bne.b	.skip
	lea	introname(pc),A0
	bsr	LoadExecutable
	jsr	(A2)
	JSRGEN	BlackScreen
	move.l	#-2,$100.W
	move.l	#$100,$DFF080
	move.l	#$100,$DFF088
	JSRGEN	BlackScreen
	bsr	UnloadExecutable
.skip
	; save score on exit

	lea	SaveScore(pc),A0
	JSRGEN	SetExitRoutine

	; load main program

	lea	progname(pc),A0
	bsr	LoadExecutable

	STORE_REGS

	move.l	A2,A3

	; search and replace possible access faults
	; (A4 is set sometimes to -1)

	move.l	A3,A0
	move.l	A0,A1
	add.l	#154000,A1
	lea	.movea4_d0(pc),A2
	move.l	#8,D0
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.exit2
	PATCHUSRJSR	(A0),MoveA4_D0
.exit2
	move.l	A3,A0
	move.l	A0,A1
	add.l	#154000,A1
	lea	.movea4_d3(pc),A2
	move.l	#8,D0
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.exit3
	PATCHUSRJSR	(A0),MoveA4_D3
.exit3
	move.l	A3,A0
	move.l	A0,A1
	add.l	#154000,A1
	lea	.movea4_d6(pc),A2
	move.l	#8,D0
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.exit4
	PATCHUSRJSR	(A0),MoveA4_D6
.exit4

	; skip joypad patch if not set

	JSRGEN	GetUserFlags
	btst	#AFB_JOYPAD,D0
	beq.b	.exit5

	move.l	A3,A0
	move.l	A0,A1
	add.l	#154000,A1
	lea	.movepotgod0(pc),A2
	move.l	#6,D0
.loop1
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.exit5
	PATCHUSRJSR	(A0),MovePotgoD0
.exit5
	move.l	A3,A0
	move.l	A0,A1
	add.l	#154000,A1
	lea	.rncdecrunch(pc),A2
	move.l	#10,D0
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.exit6
	PATCHGENJMP	(A0),RNCDecrunch
.exit6

	move.l	A3,A0
	move.l	A0,A1
	add.l	#154000,A1
	lea	.scorestart(pc),A2
	move.l	#8,D0	
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.exit7

	addq.l	#2,A0
	move.l	A0,A1
	RELOC_MOVEL	A1,hiscore_address

	lea	ScoreBuffer(pc),A0
	cmp.l	#'SHIT',(A0)
	beq.b	.exit7

	move.l	#HISCORE_LEN,D0
	JSRGEN	CopyMem
	
.exit7
	RESTORE_REGS
	rts

.scorestart:
	dc.l	$20FF2032,$30303030
.rncdecrunch:
	dc.l	$48E7FFFC,$4FEFFE80
	dc.w	$244F
.movea4_d0:
	dc.l	$3028008A,$B054660A
.movea4_d3:
	dc.l	$3628008A,$B654661C
.movea4_d6:
	dc.l	$3C28008A,$BC546610
.movepotgod0
	dc.l	$143900DF
	dc.l	$F0161602


MovePotgoD0:
	move.b	potinp+$DFF000,D2
	move.w	#$CC01,potgo+$DFF000
	rts

MOVEA4DX:MACRO
MoveA4_D\1:
	move.w	($8A,A0),D\1
	cmp.l	#-1,A4	; does the game try to access $FFFFFFFF address?
	beq.b	.avoid
	cmp.w	(A4),D\1
	rts
.avoid
	cmp.l	#0,A4	; so Z flag is cleared
	rts
	ENDM

	MOVEA4DX	0
	MOVEA4DX	3
	MOVEA4DX	6

WaitBlit:
	JSRGEN	WaitBlit
	RTS

FileErr:
	Mac_printf	"** Can't open file 'bans.exe' !"
	JMPABS	CloseAll

AgaErr:
	Mac_printf	"** You need a A1200/A4000 to run Banshee!"
	JMPABS	CloseAll

; loads an executable by calling OSEmu LoadSeg()
;
; < A0: name of the executable
; > A2: start address (do a JSR (a1) to start the program)
; ** no checks are done there so be careful **

LoadExecutable:
	movem.l	A1/A3-A6/D0-D7,-(A7)
	move.l	A0,-(A7)
	MOVE.L	$4.W,A6			;OPEN DOSLIB FOR USE (THE EMU
	MOVEQ.L	#0,D0			;PROVIDES THE FUNCTIONS)
	LEA	dosname(PC),A1
	JSRLIB	OpenLibrary
	RELOC_MOVEL	D0,dosbase
	MOVE.L	D0,A6
	move.l	(A7)+,A0

	MOVE.L	A0,D1
	JSRLIB	LoadSeg
	RELOC_MOVEL	D0,loaderseg

	LSL.L	#2,D0
	MOVE.L	D0,A2
	ADDQ.L	#4,A2

	lea	progargs(pc),A0
	move.l	A0,D0
	JSRGEN	StrlenAsm	; arguments length

	JSRGEN	FlushCachesHard
	movem.l	(A7)+,A1/A3-A6/D0-D7
	rts

; unloads previously loaded executable

UnloadExecutable:
	STORE_REGS
	move.l	dosbase(pc),A6
	move.l	loaderseg(pc),D1
	JSRLIB	UnLoadSeg
	RESTORE_REGS
	rts

nointro:
	dc.l	0
loaderseg:
	dc.l	0
dosbase:
	dc.l	0
hiscore_address:
	dc.l	0

progargs:
	; your arguments here (ex: dc.b "/f data1")
	dc.b	10,0		; linefeed + null termination
dosname:
	dc.b	"dos.library",0
;lowname:
;	dc.b	"lowlevel.library",0
progname:
	dc.b	"bans.exe",0
introname:
	dc.b	"picture.exe",0

ScoreName:
	dc.b	"banshee.hi",0
	cnop	0,4
ScoreBuffer:
	dc.b	"SHIT"	; invalid hiscore
	blk.b	HISCORE_LEN-4,0
