; *** Minskie - The Abduction HD loader v1.0
; *** Written by Jean-Franois Fabre

	include  "syslibs.i"
	include  "jst.i"

	HD_PARAMS   "",0,0

loader:
	Mac_printf  "Minskie - The Abduction ECS/AGA HD Loader v2.0"
	Mac_printf  "Coded by Jean-Franois Fabre  1999-2000"

	JSRGEN	CheckAGA
	tst.l	D0
	bne.b	.ecsversion	; force ECS if notaga computer

	JSRGEN	GetUserData
	cmp.l	#0,A0
	beq.b	.ecsversion	; force ECS if userdata not set
	RELOC_STL	aga_version
	NEWLINE	
	Mac_printf	"Loading AGA version"
.ecsversion
	bsr	ConfigureVersion

	JSRABS	Test1MBChip
	tst.l	D0
	bne	ChipErr

	move.l	mainname(pc),D0
	JSRABS	TestFile
	tst.l	D0
	bne	FileErr

	JSRABS	UseHarryOSEmu

	move.l	#40000,D0
	JSRABS	LoadSmallFiles

	moveq.l	#0,D0
	move.l	#CACRF_CopyBack,D1
	JSRABS	Degrade

	GO_SUPERVISOR

	move.l	#$100000,D0
	RELOC_TSTL	aga_version
	beq.b	.noaga
	add.l	D0,D0
.noaga

	JSRABS	SaveOSData

;;	JSRGEN	FreezeAll
	move	#$0000,SR

	bsr	InstallBoot

	; **** boot stuff and patch

	JSRGEN	FlushCachesHard

	move.l	memblock(pc),-(A7)
	add.l	#$20,(A7)

	moveq.l	#1,D0
	lea	lf(pc),A0
	rts

DecrunchAndPatch:
	RELOC_MOVEL	(4,A0),decrunched_length	; save decrunched length
	RELOC_MOVEL	A0,buffer
	bsr	ATNDecrunch		; then decrunch the file
	tst.l	D0
	beq	.exit			; not a valid imploder data file
	STORE_REGS

	move.l	buffer(pc),A0

	cmp.l	#$3F3,(A0)
	bne.b	.noexe

	; search and remove VBR shit

	move.l	A0,A1
	add.l	decrunched_length(pc),A1
	move.l	#$4E7A0801,D0
	move.l	#$70004E71,D1
	JSRGEN	HexReplaceLong

	; patch keyboard interrupt

	lea	kbintstring(pc),A2
	move.l	#12,D0
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.nokbpatch

	PATCHUSRJSR	(A0),KbInt
	move.w	#$6004,(6,A0)
.nokbpatch
	
	; patch ATN decrunch for using fastmem & reinstalling patch

	move.l	buffer(pc),A0
	move.l	A0,A1
	add.l	decrunched_length(pc),A1
	lea	atndecstring(pc),A2
	move.l	#8,D0
	JSRGEN	HexSearch
	cmp.l	#0,A0
	beq.b	.noatnpatch

	PATCHUSRJMP	(A0),DecrunchAndPatch
.noatnpatch
	JSRGEN	FlushCachesHard		; cache flush in the end
.noexe
	RESTORE_REGS
.exit
	rts

KbInt:
	bsr	kbintstring	; original code executed
	move.l	D0,-(A7)
	ror.b	#1,D0
	cmp.b	#$5D,D0
	bne.b	.noquit
	JSRGEN	InGameExit
.noquit
	move.l	(A7)+,D0
	rts

InstallBoot:
	move.l	mainsize(pc),D0
	move.l	#MEMF_CHIP,D1
	move.l	$4.W,A6
	JSRLIB	AllocMem
	RELOC_MOVEL	D0,memblock
	beq.b	Fatal

	move.l	mainname(pc),A0
	move.l	memblock(pc),A1
	move.l	mainsize(pc),D1
	moveq.l	#0,D0
	JSRGEN	ReadFile
	tst.l	D0
	bne.b	Fatal

	move.l	memblock(pc),A1
	move.l	A1,A0
	bsr	DecrunchAndPatch

	bsr	RelocateExe
	rts

Fatal:
	JSRGEN	InGameExit

ChipErr:
	Mac_printf	"** At least 1MB of chipmem needed to run Minskie!"
	JMPABS		CloseAll
FileErr:
	Mac_printf	"** File Main??.bin not found!!"
	JMPABS		CloseAll




RelocateExe:
	MOVEA.L	memblock(pc),A2		;5E4: 2479000007E8
	MOVE.L	A2,D2			;5EA: 240A
	ADDI.L	#$00000020,D2		;5EC: 068200000020
	MOVE.L	28(A2),D0		;5F2: 202A001C
	LSL.L	#2,D0			;5F6: E588
	ADDA.L	#$00000020,A2		;5F8: D5FC00000020
	MOVEA.L	A2,A3			;5FE: 264A
	ADDA.L	D0,A3			;600: D7C0
	CMPI.L	#$000003EC,(A3)		;602: 0C93000003EC
	BNE	LAB_0052		;608: 6600001C
	MOVE.L	4(A3),D0		;60C: 202B0004
	ADDA.L	#$0000000C,A3		;610: D7FC0000000C
LAB_0051:
	MOVE.L	(A3)+,D1		;616: 221B
	MOVEA.L	A2,A4			;618: 284A
	ADDA.L	D1,A4			;61A: D9C1
	ADD.L	D2,(A4)			;61C: D594
	SUBI.L	#$00000001,D0		;61E: 048000000001
	BNE.S	LAB_0051		;624: 66F0
LAB_0052:
	RTS				;626: 4E75

ConfigureVersion:
	RELOC_TSTL	aga_version
	beq.b	.ecs

	; aga version

	lea	main64name(pc),A0
	RELOC_MOVEL	A0,mainname
	RELOC_MOVEL	#1554312,mainsize	; (869844)
	rts

.ecs
	lea	main32name(pc),A0
	RELOC_MOVEL	A0,mainname
	RELOC_MOVEL	#869844,mainsize

	rts


ATNDecrunch:
	CMPI.L	#$41544E21,(A0)		;628: 0C9041544E21
	BEQ.S	LAB_0054		;62E: 670A
	CMPI.L	#$494D5021,(A0)		;630: 0C90494D5021
	BEQ.S	LAB_0054		;636: 6702
	BRA.S	LAB_0057		;638: 6030
LAB_0054:
	MOVEM.L	D2-D5/A2-A4,-(A7)	;63A: 48E73C38
	MOVEA.L	A0,A3			;63E: 2648
	MOVEA.L	A0,A4			;640: 2848
	TST.L	(A0)+			;642: 4A98
	ADDA.L	(A0)+,A4		;644: D9D8
	ADDA.L	(A0)+,A3		;646: D7D8
	MOVEA.L	A3,A2			;648: 244B
	MOVE.L	(A2)+,-(A0)		;64A: 211A
	MOVE.L	(A2)+,-(A0)		;64C: 211A
	MOVE.L	(A2)+,-(A0)		;64E: 211A
	MOVE.L	(A2)+,D2		;650: 241A
	MOVE	(A2)+,D3		;652: 361A
	BMI.S	LAB_0055		;654: 6B02
	SUBQ.L	#1,A3			;656: 538B
LAB_0055:
	LEA	-28(A7),A7		;658: 4FEFFFE4
	MOVEA.L	A7,A1			;65C: 224F
	MOVEQ	#6,D0			;65E: 7006
LAB_0056:
	MOVE.L	(A2)+,(A1)+		;660: 22DA
	DBF	D0,LAB_0056		;662: 51C8FFFC
	MOVEA.L	A7,A1			;666: 224F
	BRA.S	LAB_0058		;668: 6004
LAB_0057:
	SUB.L	D0,D0			;66A: 9080
	RTS				;66C: 4E75
LAB_0058:
	TST.L	D2			;66E: 4A82
	BEQ.S	LAB_005A		;670: 6706
LAB_0059:
	MOVE.B	-(A3),-(A4)		;672: 1923
	SUBQ.L	#1,D2			;674: 5382
	BNE.S	LAB_0059		;676: 66FA
LAB_005A:
	CMPA.L	A4,A0			;678: B1CC
	BCS.S	LAB_005C		;67A: 6514
	LEA	28(A7),A7		;67C: 4FEF001C
	MOVEQ	#-1,D0			;680: 70FF
	CMPA.L	A3,A0			;682: B1CB
	BEQ.S	LAB_005B		;684: 6702
	SUB.L	D0,D0			;686: 9080
LAB_005B:
	MOVEM.L	(A7)+,D2-D5/A2-A4	;688: 4CDF1C3C
	TST.L	D0			;68C: 4A80
	RTS				;68E: 4E75
LAB_005C:
	ADD.B	D3,D3			;690: D603
	BNE.S	LAB_005D		;692: 6604
	MOVE.B	-(A3),D3		;694: 1623
	ADDX.B	D3,D3			;696: D703
LAB_005D:
	BCC.S	LAB_0069		;698: 6468
	ADD.B	D3,D3			;69A: D603
	BNE.S	LAB_005E		;69C: 6604
	MOVE.B	-(A3),D3		;69E: 1623
	ADDX.B	D3,D3			;6A0: D703
LAB_005E:
	BCC.S	LAB_0068		;6A2: 6458
	ADD.B	D3,D3			;6A4: D603
	BNE.S	LAB_005F		;6A6: 6604
	MOVE.B	-(A3),D3		;6A8: 1623
	ADDX.B	D3,D3			;6AA: D703
LAB_005F:
	BCC.S	LAB_0067		;6AC: 6448
	ADD.B	D3,D3			;6AE: D603
	BNE.S	LAB_0060		;6B0: 6604
	MOVE.B	-(A3),D3		;6B2: 1623
	ADDX.B	D3,D3			;6B4: D703
LAB_0060:
	BCC.S	LAB_0066		;6B6: 6438
	SUB.L	D4,D4			;6B8: 9884
	ADD.B	D3,D3			;6BA: D603
	BNE.S	LAB_0061		;6BC: 6604
	MOVE.B	-(A3),D3		;6BE: 1623
	ADDX.B	D3,D3			;6C0: D703
LAB_0061:
	BCC.S	LAB_0062		;6C2: 6408
	MOVE.B	-(A3),D4		;6C4: 1823
	MOVEQ	#3,D0			;6C6: 7003
	SUBQ.B	#1,D4			;6C8: 5304
	BRA.S	LAB_006A		;6CA: 603A
LAB_0062:
	ADD.B	D3,D3			;6CC: D603
	BNE.S	LAB_0063		;6CE: 6604
	MOVE.B	-(A3),D3		;6D0: 1623
	ADDX.B	D3,D3			;6D2: D703
LAB_0063:
	ADDX.B	D4,D4			;6D4: D904
	ADD.B	D3,D3			;6D6: D603
	BNE.S	LAB_0064		;6D8: 6604
	MOVE.B	-(A3),D3		;6DA: 1623
	ADDX.B	D3,D3			;6DC: D703
LAB_0064:
	ADDX.B	D4,D4			;6DE: D904
	ADD.B	D3,D3			;6E0: D603
	BNE.S	LAB_0065		;6E2: 6604
	MOVE.B	-(A3),D3		;6E4: 1623
	ADDX.B	D3,D3			;6E6: D703
LAB_0065:
	ADDX.B	D4,D4			;6E8: D904
	ADDQ.B	#5,D4			;6EA: 5A04
	MOVEQ	#3,D0			;6EC: 7003
	BRA.S	LAB_006A		;6EE: 6016
LAB_0066:
	MOVEQ	#4,D4			;6F0: 7804
	MOVEQ	#3,D0			;6F2: 7003
	BRA.S	LAB_006A		;6F4: 6010
LAB_0067:
	MOVEQ	#3,D4			;6F6: 7803
	MOVEQ	#2,D0			;6F8: 7002
	BRA.S	LAB_006A		;6FA: 600A
LAB_0068:
	MOVEQ	#2,D4			;6FC: 7802
	MOVEQ	#1,D0			;6FE: 7001
	BRA.S	LAB_006A		;700: 6004
LAB_0069:
	MOVEQ	#1,D4			;702: 7801
	SUB.L	D0,D0			;704: 9080
LAB_006A:
	SUB.L	D5,D5			;706: 9A85
	MOVE	D0,D1			;708: 3200
	ADD.B	D3,D3			;70A: D603
	BNE.S	LAB_006B		;70C: 6604
	MOVE.B	-(A3),D3		;70E: 1623
	ADDX.B	D3,D3			;710: D703
LAB_006B:
	BCC.S	LAB_006E		;712: 6416
	ADD.B	D3,D3			;714: D603
	BNE.S	LAB_006C		;716: 6604
	MOVE.B	-(A3),D3		;718: 1623
	ADDX.B	D3,D3			;71A: D703
LAB_006C:
	BCC.S	LAB_006D		;71C: 6408
	MOVE.B	LAB_0078(PC,D0),D5	;71E: 1A3B006A
	ADDQ.B	#8,D0			;722: 5000
	BRA.S	LAB_006E		;724: 6004
LAB_006D:
	MOVEQ	#2,D5			;726: 7A02
	ADDQ.B	#4,D0			;728: 5800
LAB_006E:
	MOVE.B	LAB_0079(PC,D0),D0	;72A: 103B0062
LAB_006F:
	ADD.B	D3,D3			;72E: D603
	BNE.S	LAB_0070		;730: 6604
	MOVE.B	-(A3),D3		;732: 1623
	ADDX.B	D3,D3			;734: D703
LAB_0070:
	ADDX	D2,D2			;736: D542
	SUBQ.B	#1,D0			;738: 5300
	BNE.S	LAB_006F		;73A: 66F2
	ADD	D5,D2			;73C: D445
	SUB.L	D5,D5			;73E: 9A85
	MOVEA.L	D5,A2			;740: 2445
	MOVE	D1,D0			;742: 3001
	ADD.B	D3,D3			;744: D603
	BNE.S	LAB_0071		;746: 6604
	MOVE.B	-(A3),D3		;748: 1623
	ADDX.B	D3,D3			;74A: D703
LAB_0071:
	BCC.S	LAB_0074		;74C: 641A
	ADD	D1,D1			;74E: D241
	ADD.B	D3,D3			;750: D603
	BNE.S	LAB_0072		;752: 6604
	MOVE.B	-(A3),D3		;754: 1623
	ADDX.B	D3,D3			;756: D703
LAB_0072:
	BCC.S	LAB_0073		;758: 6408
	MOVEA	8(A1,D1),A2		;75A: 34711008
	ADDQ.B	#8,D0			;75E: 5000
	BRA.S	LAB_0074		;760: 6006
LAB_0073:
	MOVEA	0(A1,D1),A2		;762: 34711000
	ADDQ.B	#4,D0			;766: 5800
LAB_0074:
	MOVE.B	16(A1,D0),D0		;768: 10310010
LAB_0075:
	ADD.B	D3,D3			;76C: D603
	BNE.S	LAB_0076		;76E: 6604
	MOVE.B	-(A3),D3		;770: 1623
	ADDX.B	D3,D3			;772: D703
LAB_0076:
	ADDX.L	D5,D5			;774: DB85
	SUBQ.B	#1,D0			;776: 5300
	BNE.S	LAB_0075		;778: 66F2
	ADDQ	#1,A2			;77A: 524A
	ADDA.L	D5,A2			;77C: D5C5
	ADDA.L	A4,A2			;77E: D5CC
LAB_0077:
	MOVE.B	-(A2),-(A4)		;780: 1922
	DBF	D4,LAB_0077		;782: 51CCFFFC
	BRA	LAB_0058		;786: 6000FEE6
LAB_0078:
	DC.W	$060A			;78A
	DC.W	$0A12			;78C
LAB_0079:
	dc.w	$0101
	dc.w	$0101
	DC.W	$0203			;792
	dc.w	$0304
	DC.W	$0405			;796
	dc.l	$070E0000
	dc.l	0,0,0,0

memblock:
	dc.l  0
ExtBase:
	dc.l  0
aga_version:
	dc.l	0
mainname:
	dc.l	0
mainsize:
	dc.l	0
decrunched_length:
	dc.l	0
buffer:
	dc.l	0
atndecstring:
	dc.l	$0C904154,$4E21670A
kbintstring:
	dc.w	$102b
	dc.l	$0c004600,$177c0000
	dc.w	$0c00
	rts
main64name:
	dc.b	"main64.bin",0
main32name:
	dc.b	"main32.bin",0
lf:
	dc.b	10,0

